function [x]=Chasing(A,b)
sizeA=size(A);
n=sizeA(1);
[L,U]=decom(A,n);
y=solveL(L,b,n);
x=solveU(U,y,n);
end
function [L,U]=decom(A,n)
L=eye(n,n);
U=triu(A);
U(1,1)=A(1,1);
for i=2:n
    L(i,i-1)=A(i,i-1)/U(i-1,i-1);
    U(i,i)=A(i,i)-L(i,i-1)*A(i-1,i);
end
end
function [y]=solveL(L,b,n)
y=zeros(n,1);
y(1)=b(1)/L(1,1);
for i=2:n
    y(i)=(b(i)-L(i,1:i-1)*y(1:i-1,1))/L(i,i);
end
end
function [x]=solveU(U,y,n)
x=zeros(n,1);
x(n)=y(n)/U(n,n);
for i=n-1:-1:1
    x(i)=(y(i)-U(i,i+1:n)*x(i+1:n,1))/U(i,i);
end
end